]> git.ipfire.org Git - ipfire-2.x.git/blame - make.sh
oci-python-sdk: New package
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
7c067608 20# Copyright (C) 2007-2022 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
d12e3fcd 27# If you update the version don't forget to update backupiso and add it to core update
255273a3 28VERSION="2.27" # Version number
7c067608 29CORE="165" # Core Level (Filename)
e8ee3199
AF
30SLOGAN="www.ipfire.org" # Software slogan
31CONFIG_ROOT=/var/ipfire # Configuration rootdir
e8ee3199 32MAX_RETRIES=1 # prefetch/check loop
305a7b38 33BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 34KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
36e2e992
MT
35
36# Information from Git
37GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
38GIT_TAG="$(git tag | tail -1)" # Git Tag
39GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
628e8c3a 40
bc797557 41TOOLCHAINVER=20220203
03ad5f93 42
178eaf31
AF
43# use multicore and max compression
44ZSTD_OPT="-T0 --ultra -22"
d66e6fa8 45
69a6ec55
MT
46###############################################################################
47#
48# Beautifying variables & presentation & input output interface
49#
50###############################################################################
51
f9783277
MT
52# Remember if the shell is interactive or not
53if [ -t 0 ] && [ -t 1 ]; then
54 INTERACTIVE=true
55else
56 INTERACTIVE=false
57fi
58
401a1edc
MT
59# Sets or adjusts pretty formatting variables
60resize_terminal() {
61 ## Screen Dimentions
62 # Find current screen size
63 COLUMNS=$(tput cols)
64
65 # When using remote connections, such as a serial port, stty size returns 0
66 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
67 COLUMNS=80
68 fi
69a6ec55 69
401a1edc
MT
70 # Measurements for positioning result messages
71 OPTIONS_WIDTH=20
72 TIME_WIDTH=12
73 STATUS_WIDTH=8
74 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
75 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
76
e9a57acd
MT
77 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
78 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 79}
69a6ec55 80
401a1edc
MT
81# Initially setup terminal
82resize_terminal
f9783277 83
401a1edc
MT
84# Call resize_terminal when terminal is being resized
85trap "resize_terminal" WINCH
69a6ec55
MT
86
87# Define color for messages
88BOLD="\\033[1;39m"
89DONE="\\033[1;32m"
90SKIP="\\033[1;34m"
91WARN="\\033[1;35m"
92FAIL="\\033[1;31m"
93NORMAL="\\033[0;39m"
94
bcb9dc13 95# New architecture variables
dc7d6b20 96HOST_ARCH="$(uname -m)"
94571564 97
69a6ec55
MT
98PWD=$(pwd)
99BASENAME=$(basename $0)
100
15679d9f
MT
101# Debian specific settings
102if [ ! -e /etc/debian_version ]; then
df5e82b3 103 FULLPATH=`which $0`
15679d9f 104else
df5e82b3
MT
105 if [ -x /usr/bin/realpath ]; then
106 FULLPATH=`/usr/bin/realpath $0`
107 else
108 echo "ERROR: Need to do apt-get install realpath"
109 exit 1
110 fi
15679d9f 111fi
df5e82b3 112
69a6ec55 113# This is the directory where make.sh is in
aecbe123 114export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 115
ebaecf2c
AF
116LOGFILE=$BASEDIR/log/_build.preparation.log
117export LOGFILE
15679d9f 118DIR_CHK=$BASEDIR/cache/check
ebaecf2c 119mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 120
69a6ec55
MT
121system_processors() {
122 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
123}
124
125system_memory() {
126 local key val unit
127
128 while read -r key val unit; do
129 case "${key}" in
130 MemTotal:*)
131 # Convert to MB
132 echo "$(( ${val} / 1024 ))"
133 break
134 ;;
135 esac
136 done < /proc/meminfo
137}
138
139configure_build() {
140 local build_arch="${1}"
141
142 if [ "${build_arch}" = "default" ]; then
143 build_arch="$(configure_build_guess)"
144 fi
145
146 case "${build_arch}" in
147 x86_64)
c1d646bf 148 BUILDTARGET="${build_arch}-pc-linux-gnu"
69a6ec55
MT
149 CROSSTARGET="${build_arch}-cross-linux-gnu"
150 BUILD_PLATFORM="x86"
5eec0f21 151 CFLAGS_ARCH="-m64 -mtune=generic -fstack-clash-protection -fcf-protection"
69a6ec55
MT
152 ;;
153
69a6ec55 154 aarch64)
c1d646bf 155 BUILDTARGET="${build_arch}-pc-linux-gnu"
69a6ec55
MT
156 CROSSTARGET="${build_arch}-cross-linux-gnu"
157 BUILD_PLATFORM="arm"
87f3b1e5 158 CFLAGS_ARCH="-fstack-clash-protection"
69a6ec55
MT
159 ;;
160
161 armv7hl)
c1d646bf 162 BUILDTARGET="${build_arch}-pc-linux-gnueabi"
69a6ec55
MT
163 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
164 BUILD_PLATFORM="arm"
165 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
166 ;;
167
aafdd71b 168 armv6l)
c1d646bf 169 BUILDTARGET="${build_arch}-pc-linux-gnueabi"
69a6ec55
MT
170 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
171 BUILD_PLATFORM="arm"
f3fda4d3 172 CFLAGS_ARCH="-march=armv6zk+fp -mfpu=vfp -mfloat-abi=softfp -fomit-frame-pointer"
69a6ec55
MT
173 ;;
174
161eb15d 175 riscv64)
c1d646bf 176 BUILDTARGET="${build_arch}-pc-linux-gnu"
161eb15d
MT
177 CROSSTARGET="${build_arch}-cross-linux-gnu"
178 BUILD_PLATFORM="riscv"
0c304b7b 179 CFLAGS_ARCH="-fstack-clash-protection"
161eb15d
MT
180 ;;
181
69a6ec55
MT
182 *)
183 exiterror "Cannot build for architure ${build_arch}"
184 ;;
185 esac
186
187 # Check if the QEMU helper is available if needed.
188 if qemu_is_required "${build_arch}"; then
189 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
190
191 if [ -n "${qemu_build_helper}" ]; then
192 QEMU_TARGET_HELPER="${qemu_build_helper}"
193 else
194 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
195 fi
196 fi
197
198 BUILD_ARCH="${build_arch}"
199 TOOLS_DIR="/tools_${BUILD_ARCH}"
200
201 # Enables hardening
54114eb0 202 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
69a6ec55
MT
203
204 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
205 CXXFLAGS="${CFLAGS}"
206
c75e90c8
MT
207 RUSTFLAGS="-Copt-level=3 -Clink-arg=-Wl,-z,relro,-z,now -Ccodegen-units=1 --cap-lints=warn ${RUSTFLAGS_ARCH}"
208
69a6ec55 209 # Determine parallelism
eeee108f 210 # We assume that each process consumes about
297473d5 211 # 128MB of memory. Therefore we find out how
eeee108f 212 # many processes fit into memory.
297473d5 213 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
72c39057 214 local cpu_max=$(( ${SYSTEM_PROCESSORS} ))
eeee108f
MT
215
216 local parallelism
217 if [ ${mem_max} -lt ${cpu_max} ]; then
218 parallelism=${mem_max}
219 else
220 parallelism=${cpu_max}
69a6ec55 221 fi
212f17c1 222
eeee108f
MT
223 # Use this as default PARALLELISM
224 DEFAULT_PARALLELISM="${parallelism}"
225
e1616eb4
SS
226 # Limit lauched ninja build jobs to computed parallel value.
227 NINJAJOBS="${parallelism}"
228
212f17c1
MT
229 # Compression parameters
230 # We use mode 8 for reasonable memory usage when decompressing
231 # but with overall good compression
232 XZ_OPT="-8"
233
234 # We try to use as many cores as possible
235 XZ_OPT="${XZ_OPT} -T0"
236
237 # We need to limit memory because XZ uses too much when running
238 # in parallel and it isn't very smart in limiting itself.
239 # We allow XZ to use up to 70% of all system memory.
deffc275 240 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
212f17c1
MT
241
242 # XZ memory cannot be larger than 2GB on 32 bit systems
243 case "${build_arch}" in
6cf219c4 244 armv*)
212f17c1
MT
245 if [ ${xz_memory} -gt 2048 ]; then
246 xz_memory=2048
247 fi
248 ;;
249 esac
250
251 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
69a6ec55
MT
252}
253
254configure_build_guess() {
255 case "${HOST_ARCH}" in
87487585
MT
256 x86_64)
257 echo "x86_64"
258 ;;
69a6ec55
MT
259
260 aarch64)
261 echo "aarch64"
262 ;;
263
aafdd71b
AF
264 armv7*|armv6*)
265 echo "armv6l"
69a6ec55
MT
266 ;;
267
161eb15d
MT
268 riscv64)
269 echo "riscv64"
270 ;;
271
69a6ec55
MT
272 *)
273 exiterror "Cannot guess build architecture"
274 ;;
275 esac
276}
277
f9783277
MT
278stdumount() {
279 umount $BASEDIR/build/sys 2>/dev/null;
280 umount $BASEDIR/build/dev/shm 2>/dev/null;
281 umount $BASEDIR/build/dev/pts 2>/dev/null;
282 umount $BASEDIR/build/dev 2>/dev/null;
283 umount $BASEDIR/build/proc 2>/dev/null;
284 umount $BASEDIR/build/install/mnt 2>/dev/null;
285 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
286 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
287 umount $BASEDIR/build/usr/src/config 2>/dev/null;
288 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
289 umount $BASEDIR/build/usr/src/html 2>/dev/null;
290 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
291 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
ebaecf2c 292 umount $BASEDIR/build/usr/src/log 2>/dev/null;
f9783277 293 umount $BASEDIR/build/usr/src/src 2>/dev/null;
7c984de6 294 umount $BASEDIR/build/usr/src 2>/dev/null;
cb658c8c 295 umount $BASEDIR/build/tmp 2>/dev/null;
f9783277
MT
296}
297
298now() {
299 date -u "+%s"
69a6ec55
MT
300}
301
f9783277
MT
302format_runtime() {
303 local seconds=${1}
304
305 if [ ${seconds} -ge 3600 ]; then
306 printf "%d:%02d:%02d\n" \
307 "$(( seconds / 3600 ))" \
308 "$(( seconds % 3600 / 60 ))" \
309 "$(( seconds % 3600 % 60 ))"
310 elif [ ${seconds} -ge 60 ]; then
311 printf "%d:%02d\n" \
312 "$(( seconds / 60 ))" \
313 "$(( seconds % 60 ))"
69a6ec55 314 else
f9783277 315 printf "%d\n" "${seconds}"
69a6ec55 316 fi
f9783277 317}
69a6ec55 318
f9783277
MT
319print_line() {
320 local line="$@"
69a6ec55 321
f9783277 322 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
323}
324
f9783277
MT
325_print_line() {
326 local status="${1}"
327 shift
69a6ec55 328
f9783277
MT
329 if ${INTERACTIVE}; then
330 printf "${!status}"
331 fi
69a6ec55 332
f9783277
MT
333 print_line "$@"
334
335 if ${INTERACTIVE}; then
336 printf "${NORMAL}"
337 fi
338}
339
340print_headline() {
341 _print_line BOLD "$@"
69a6ec55
MT
342}
343
f9783277
MT
344print_error() {
345 _print_line FAIL "$@"
346}
347
348print_package() {
349 local name="${1}"
350 shift
69a6ec55 351
f9783277
MT
352 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
353 local options="$@"
354
355 local string="${name}"
356 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
357 string="${string} (${version})"
358 fi
359
360 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 361 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
362}
363
364print_runtime() {
365 local runtime=$(format_runtime $@)
366
367 if ${INTERACTIVE}; then
368 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
369 else
370 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 371 fi
f9783277
MT
372}
373
374print_status() {
375 local status="${1}"
376
377 local color="${!status}"
378
379 if ${INTERACTIVE}; then
380 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
381 else
382 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 383 fi
f9783277 384}
69a6ec55 385
f9783277
MT
386print_build_stage() {
387 print_headline "$@"
388
389 # end line
390 printf "\n"
69a6ec55
MT
391}
392
f9783277
MT
393print_build_summary() {
394 local runtime=$(format_runtime $@)
395
396 print_line "*** Build finished in ${runtime}"
397 print_status DONE
69a6ec55
MT
398}
399
400exiterror() {
401 stdumount
402 for i in `seq 0 7`; do
403 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
404 losetup -d /dev/loop${i} 2>/dev/null
405 fi;
406 done
407
f9783277 408 # Dump logfile
66028310 409 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
410 echo # empty line
411
412 local line
413 while read -r line; do
414 echo " ${line}"
415 done <<< "$(tail -n30 ${LOGFILE})"
416 fi
417
f9783277
MT
418 echo # empty line
419
420 local line
421 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
422 print_error "${line}"
423 print_status FAIL
424 done
425
69a6ec55
MT
426 exit 1
427}
428
aecbe123
MT
429prepareenv() {
430 # Are we running the right shell?
54328605 431 if [ -z "${BASH}" ]; then
aecbe123
MT
432 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
433 fi
434
435 if [ -z "${BASH_VERSION}" ]; then
436 exiterror "Not running BASH shell."
437 fi
438
439 # Trap on emergency exit
db9ba592 440 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGQUIT
aecbe123 441
aecbe123 442 # Checking if running as root user
658232a6 443 if [ $(id -u) -ne 0 ]; then
df7f30a1 444 exiterror "root privileges required for building"
aecbe123
MT
445 fi
446
447 # Checking for necessary temporary space
f9783277 448 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
449 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
450 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
451 if (( 2048000 > $BASE_ASPACE )); then
452 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
453 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 454 print_status FAIL
aecbe123
MT
455 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
456 fi
457 else
f9783277 458 print_status DONE
aecbe123
MT
459 fi
460
461 # Set umask
462 umask 022
463
464 # Set LFS Directory
465 LFS=$BASEDIR/build
466
aecbe123
MT
467 # Setup environment
468 set +h
469 LC_ALL=POSIX
e1616eb4 470 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS NINJAJOBS
aecbe123
MT
471 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
472
473 # Make some extra directories
474 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
475 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
476 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
380aa6e5 477 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}/${TOOLCHAINVER}} 2>/dev/null
7c984de6
MT
478
479 if [ "${ENABLE_RAMDISK}" = "on" ]; then
480 mkdir -p $BASEDIR/build/usr/src
815ca15d 481 mount -t tmpfs tmpfs -o size=8G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
ad853b56
MT
482
483 mkdir -p ${BASEDIR}/build/tmp
484 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
7c984de6
MT
485 fi
486
ebaecf2c 487 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
aecbe123
MT
488
489 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
490 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
491
492 # Make all sources and proc available under lfs build
493 mount --bind /dev $BASEDIR/build/dev
494 mount --bind /dev/pts $BASEDIR/build/dev/pts
495 mount --bind /dev/shm $BASEDIR/build/dev/shm
496 mount --bind /proc $BASEDIR/build/proc
497 mount --bind /sys $BASEDIR/build/sys
498 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
380aa6e5 499 mount --bind $BASEDIR/ccache/${BUILD_ARCH}/${TOOLCHAINVER} $BASEDIR/build/usr/src/ccache
aecbe123
MT
500 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
501 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
502 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
503 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
504 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
ebaecf2c 505 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
aecbe123
MT
506 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
507
508 # Run LFS static binary creation scripts one by one
509 export CCACHE_DIR=$BASEDIR/ccache
36065e42 510 export CCACHE_TEMPDIR="/tmp"
aecbe123
MT
511 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
512
513 # Remove pre-install list of installed files in case user erase some files before rebuild
514 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
515
516 # Prepare string for /etc/system-release.
f48643e5
MT
517 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
518
519 case "${GIT_BRANCH}" in
520 core*|beta?|rc?)
521 system_release="${system_release} - ${GIT_BRANCH}"
522 ;;
523 *)
9ff65bfa 524 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
f48643e5 525 ;;
aecbe123 526 esac
4e54a8e2 527
f48643e5
MT
528 # Append -dirty tag for local changes
529 if [ "$(git status -s | wc -l)" != "0" ]; then
530 system_release="${system_release}-dirty"
531 fi
532
533 # Export variable
534 SYSTEM_RELEASE="${system_release}"
535
040160c7
MT
536 # Decide on PAKFIRE_TREE
537 case "${GIT_BRANCH}" in
538 core*)
539 PAKFIRE_TREE="stable"
540 ;;
541 master)
542 PAKFIRE_TREE="testing"
543 ;;
544 *)
545 PAKFIRE_TREE="unstable"
546 ;;
547 esac
548
4e54a8e2
MT
549 # Setup ccache cache size
550 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
aecbe123
MT
551}
552
69a6ec55
MT
553enterchroot() {
554 # Install QEMU helper, if needed
555 qemu_install_helper
556
786ed505 557 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/sbin:${TOOLS_DIR}/bin"
69a6ec55 558
19054331
MT
559 # Prepend any custom changes to PATH
560 if [ -n "${CUSTOM_PATH}" ]; then
561 PATH="${CUSTOM_PATH}:${PATH}"
562 fi
563
69a6ec55
MT
564 PATH="${PATH}" chroot ${LFS} env -i \
565 HOME="/root" \
566 TERM="${TERM}" \
567 PS1="${PS1}" \
568 PATH="${PATH}" \
569 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
040160c7 570 PAKFIRE_TREE="${PAKFIRE_TREE}" \
69a6ec55
MT
571 NAME="${NAME}" \
572 SNAME="${SNAME}" \
573 VERSION="${VERSION}" \
574 CORE="${CORE}" \
575 SLOGAN="${SLOGAN}" \
576 TOOLS_DIR="${TOOLS_DIR}" \
577 CONFIG_ROOT="${CONFIG_ROOT}" \
578 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
579 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
82454983 580 RUSTFLAGS="${RUSTFLAGS}" \
69a6ec55
MT
581 BUILDTARGET="${BUILDTARGET}" \
582 CROSSTARGET="${CROSSTARGET}" \
583 BUILD_ARCH="${BUILD_ARCH}" \
584 BUILD_PLATFORM="${BUILD_PLATFORM}" \
585 CCACHE_DIR=/usr/src/ccache \
36065e42 586 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55 587 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
486112ad 588 GOCACHE="/usr/src/ccache/go" \
69a6ec55 589 KVER="${KVER}" \
0d7a6f03 590 XZ_OPT="${XZ_OPT}" \
77c863a2 591 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
592 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
593 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
594 $(fake_environ) \
595 $(qemu_environ) \
596 "$@"
597}
598
599entershell() {
600 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
601 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
602 fi
603
604 echo "Entering to a shell inside LFS chroot, go out with exit"
ab8464f4 605 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
69a6ec55
MT
606
607 if enterchroot bash -i; then
608 stdumount
609 else
f9783277 610 print_status FAIL
69a6ec55
MT
611 exiterror "chroot error"
612 fi
613}
614
615lfsmakecommoncheck() {
616 # Script present?
617 if [ ! -f $BASEDIR/lfs/$1 ]; then
618 exiterror "No such file or directory: $BASEDIR/$1"
619 fi
620
f9783277
MT
621 # Print package name and version
622 print_package $@
69a6ec55
MT
623
624 # Check if this package is supported by our architecture.
625 # If no SUP_ARCH is found, we assume the package can be built for all.
626 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
627 # Check if package supports ${BUILD_ARCH} or all architectures.
628 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 629 print_runtime 0
f9783277 630 print_status SKIP
69a6ec55
MT
631 return 1
632 fi
633 fi
634
635 # Script slipped?
636 local i
637 for i in $SKIP_PACKAGE_LIST
638 do
639 if [ "$i" == "$1" ]; then
f9783277 640 print_status SKIP
69a6ec55
MT
641 return 1;
642 fi
643 done
644
645 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
646
647 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
648 MESSAGE="$1\t " download >> $LOGFILE 2>&1
649 if [ $? -ne 0 ]; then
650 exiterror "Download error in $1"
651 fi
652
653 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
654 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
655 if [ $? -ne 0 ]; then
656 exiterror "md5sum error in $1, check file in cache or signature"
657 fi
658
659 return 0 # pass all!
660}
661
662lfsmake1() {
663 lfsmakecommoncheck $*
664 [ $? == 1 ] && return 0
665
1c74bc46
MT
666 # Set PATH to use the toolchain tools first and then whatever the host has set
667 local PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/sbin:${TOOLS_DIR}/bin:${PATH}"
668
0ce11c68 669 if [ -n "${CUSTOM_PATH}" ]; then
1c74bc46 670 PATH="${CUSTOM_PATH}:${PATH}"
0ce11c68
MT
671 fi
672
69a6ec55 673 cd $BASEDIR/lfs && env -i \
0ce11c68 674 PATH="${PATH}" \
4301024b 675 CCACHE_DIR="${CCACHE_DIR}"/${BUILD_ARCH}/${TOOLCHAINVER} \
36065e42 676 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55
MT
677 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
678 CFLAGS="${CFLAGS}" \
679 CXXFLAGS="${CXXFLAGS}" \
77c863a2 680 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
681 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
682 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
683 make -f $* \
684 TOOLCHAIN=1 \
685 TOOLS_DIR="${TOOLS_DIR}" \
686 CROSSTARGET="${CROSSTARGET}" \
687 BUILDTARGET="${BUILDTARGET}" \
688 BUILD_ARCH="${BUILD_ARCH}" \
689 BUILD_PLATFORM="${BUILD_PLATFORM}" \
690 LFS_BASEDIR="${BASEDIR}" \
691 ROOT="${LFS}" \
692 KVER="${KVER}" \
f9783277 693 install >> $LOGFILE 2>&1 &
69a6ec55 694
f9783277
MT
695 if ! wait_until_finished $!; then
696 print_status FAIL
697 exiterror "Building $*"
69a6ec55
MT
698 fi
699
f9783277 700 print_status DONE
69a6ec55
MT
701}
702
703lfsmake2() {
704 lfsmakecommoncheck $*
705 [ $? == 1 ] && return 0
706
69a6ec55
MT
707 local PS1='\u:\w$ '
708
709 enterchroot \
19054331 710 bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
711 make -f $* \
712 LFS_BASEDIR=/usr/src install" \
f9783277 713 >> ${LOGFILE} 2>&1 &
69a6ec55 714
f9783277
MT
715 if ! wait_until_finished $!; then
716 print_status FAIL
717 exiterror "Building $*"
69a6ec55
MT
718 fi
719
f9783277 720 print_status DONE
69a6ec55
MT
721}
722
723ipfiredist() {
724 lfsmakecommoncheck $*
725 [ $? == 1 ] && return 0
726
69a6ec55
MT
727 local PS1='\u:\w$ '
728
729 enterchroot \
730 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 731 >> ${LOGFILE} 2>&1 &
69a6ec55 732
f9783277
MT
733 if ! wait_until_finished $!; then
734 print_status FAIL
735 exiterror "Packaging $*"
736 fi
69a6ec55 737
f9783277
MT
738 print_status DONE
739}
740
741wait_until_finished() {
742 local pid=${1}
743
744 local start_time=$(now)
745
746 # Show progress
747 if ${INTERACTIVE}; then
748 # Wait a little just in case the process
749 # has finished very quickly.
750 sleep 0.1
751
752 local runtime
753 while kill -0 ${pid} 2>/dev/null; do
754 print_runtime $(( $(now) - ${start_time} ))
755
756 # Wait a little
757 sleep 1
758 done
69a6ec55 759 fi
f9783277
MT
760
761 # Returns the exit code of the child process
762 wait ${pid}
763 local ret=$?
764
765 if ! ${INTERACTIVE}; then
766 print_runtime $(( $(now) - ${start_time} ))
767 fi
768
769 return ${ret}
69a6ec55
MT
770}
771
772fake_environ() {
773 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
774
775 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
776
777 # Fake kernel version, because some of the packages do not compile
778 # with kernel 3.0 and later.
8634797e 779 env="${env} UTS_RELEASE=${KVER}-ipfire"
69a6ec55
MT
780
781 # Fake machine version.
782 env="${env} UTS_MACHINE=${BUILD_ARCH}"
783
784 echo "${env}"
785}
786
787qemu_environ() {
788 local env
789
790 # Don't add anything if qemu is not used.
791 if ! qemu_is_required; then
792 return
793 fi
794
795 # Set default qemu options
796 case "${BUILD_ARCH}" in
797 arm*)
798 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
799
800 env="${env} QEMU_CPU=${QEMU_CPU}"
801 ;;
802 esac
803
804 # Enable QEMU strace
805 #env="${env} QEMU_STRACE=1"
806
807 echo "${env}"
808}
809
810qemu_is_required() {
811 local build_arch="${1}"
812
813 if [ -z "${build_arch}" ]; then
814 build_arch="${BUILD_ARCH}"
815 fi
816
817 case "${HOST_ARCH},${build_arch}" in
161eb15d 818 x86_64,arm*|x86_64,aarch64|x86_64,riscv64|i?86,arm*|i?86,aarch64|i?86,x86_64)
69a6ec55
MT
819 return 0
820 ;;
821 *)
822 return 1
823 ;;
824 esac
825}
826
827qemu_install_helper() {
828 # Do nothing, if qemu is not required
829 if ! qemu_is_required; then
830 return 0
831 fi
832
833 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
834 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
835 fi
836
837 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
838 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
839 fi
840
841
842 if [ -z "${QEMU_TARGET_HELPER}" ]; then
843 exiterror "QEMU_TARGET_HELPER not set"
844 fi
845
846 # Check if the helper is already installed.
847 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
848 return 0
849 fi
850
851 # Try to find a suitable binary that we can install
852 # to the build environment.
853 local file
854 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
855 # file must exist and be executable.
856 [ -x "${file}" ] || continue
857
858 # Must be static.
859 file_is_static "${file}" || continue
860
861 local dirname="${LFS}$(dirname "${file}")"
862 mkdir -p "${dirname}"
863
864 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
865 return 0
866 done
867
868 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
869}
870
871qemu_find_build_helper_name() {
872 local build_arch="${1}"
873
874 local magic
875 case "${build_arch}" in
0db0f7fa
AF
876 aarch64)
877 magic="7f454c460201010000000000000000000200b700"
878 ;;
4576ca4c
MT
879 arm*)
880 magic="7f454c4601010100000000000000000002002800"
881 ;;
161eb15d
MT
882 riscv64)
883 magic="7f454c460201010000000000000000000200f300"
884 ;;
69a6ec55
MT
885 x86_64)
886 magic="7f454c4602010100000000000000000002003e00"
887 ;;
888 esac
889
890 [ -z "${magic}" ] && return 1
891
892 local file
893 for file in /proc/sys/fs/binfmt_misc/*; do
894 # skip write only register entry
895 [ $(basename "${file}") = "register" ] && continue
896 # Search for the file with the correct magic value.
897 grep -qE "^magic ${magic}$" "${file}" || continue
898
899 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
900
901 [ -n "${interpreter}" ] || continue
902 [ "${interpreter:0:1}" = "/" ] || continue
903 [ -x "${interpreter}" ] || continue
904
905 echo "${interpreter}"
906 return 0
907 done
908
909 return 1
910}
911
912file_is_static() {
913 local file="${1}"
914
915 file ${file} 2>/dev/null | grep -q "statically linked"
916}
917
918update_language_list() {
919 local path="${1}"
920
921 local lang
922 for lang in ${path}/*.po; do
923 lang="$(basename "${lang}")"
924 echo "${lang%*.po}"
925 done | sort -u > "${path}/LINGUAS"
926}
927
1fb7f56e
MT
928contributors() {
929 local commits name
930
931 git shortlog --summary --numbered | while read -r commits name; do
932 echo "${name}"
933 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
934}
935
936update_contributors() {
937 echo -n "Updating list of contributors"
938
939 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
940
941 # Edit contributors into credits.cgi
e2338aa7
MT
942 local tmp="$(mktemp)"
943
944 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
945 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
946
947 # Copy back modified content
948 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
949 unlink "${tmp}"
1fb7f56e
MT
950
951 print_status DONE
952 return 0
953}
954
15b005d8 955# Default settings
99597de7 956CCACHE_CACHE_SIZE="4G"
15b005d8
MT
957ENABLE_RAMDISK="auto"
958
a98ab1d7
MT
959# Load configuration file
960if [ -f .config ]; then
961 . .config
962fi
963
813659f2
MT
964# TARGET_ARCH is BUILD_ARCH now
965if [ -n "${TARGET_ARCH}" ]; then
966 BUILD_ARCH="${TARGET_ARCH}"
967 unset TARGET_ARCH
968fi
969
85560933
MT
970# Get some information about the host system
971SYSTEM_PROCESSORS="$(system_processors)"
972SYSTEM_MEMORY="$(system_memory)"
973
dc7d6b20
MT
974if [ -n "${BUILD_ARCH}" ]; then
975 configure_build "${BUILD_ARCH}"
949544f5 976else
dc7d6b20 977 configure_build "default"
949544f5
MT
978fi
979
15b005d8
MT
980# Automatically enable/disable ramdisk usage
981if [ "${ENABLE_RAMDISK}" = "auto" ]; then
982 # Enable only when the host system has 4GB of RAM or more
983 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
984 ENABLE_RAMDISK="on"
985 fi
986fi
987
df5e82b3 988buildtoolchain() {
69a6ec55
MT
989 local error=false
990 case "${BUILD_ARCH}:${HOST_ARCH}" in
991 # x86_64
992 x86_64:x86_64)
993 # This is working.
994 ;;
995
69a6ec55
MT
996 # ARM
997 arvm7hl:armv7hl|armv7hl:armv7l)
998 # These are working.
999 ;;
1000
aafdd71b 1001 armv6l:armv6l|armv6l:armv7l|armv6l:aarch64)
69a6ec55
MT
1002 # These are working.
1003 ;;
aafdd71b 1004 armv6l:*)
69a6ec55
MT
1005 error=true
1006 ;;
1007 esac
1008
1009 ${error} && \
1010 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
1011
1012 local gcc=$(type -p gcc)
1013 if [ -z "${gcc}" ]; then
1014 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1015 fi
1016
6bd3a131
MT
1017 # Check ${TOOLS_DIR} symlink
1018 if [ -h "${TOOLS_DIR}" ]; then
1019 rm -f "${TOOLS_DIR}"
1020 fi
1021
1022 if [ ! -e "${TOOLS_DIR}" ]; then
1023 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1024 fi
1025
1026 if [ ! -h "${TOOLS_DIR}" ]; then
1027 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1028 fi
1029
ebaecf2c 1030 LOGFILE="$BASEDIR/log/_build.toolchain.log"
69a6ec55
MT
1031 export LOGFILE
1032
1033 lfsmake1 stage1
69a6ec55
MT
1034 lfsmake1 binutils PASS=1
1035 lfsmake1 gcc PASS=1
1036 lfsmake1 linux KCFG="-headers"
1037 lfsmake1 glibc
178c7a6a 1038 lfsmake1 libxcrypt
69a6ec55 1039 lfsmake1 gcc PASS=L
54d54148 1040 lfsmake1 zlib
7d14c775
MT
1041 lfsmake1 binutils PASS=2
1042 lfsmake1 gcc PASS=2
0250d332 1043 lfsmake1 zstd
74ee1c7a 1044 lfsmake1 ccache
69a6ec55
MT
1045 lfsmake1 tcl
1046 lfsmake1 expect
1047 lfsmake1 dejagnu
1048 lfsmake1 pkg-config
1049 lfsmake1 ncurses
1050 lfsmake1 bash
1051 lfsmake1 bzip2
1052 lfsmake1 automake
1053 lfsmake1 coreutils
1054 lfsmake1 diffutils
1055 lfsmake1 findutils
1056 lfsmake1 gawk
1057 lfsmake1 gettext
1058 lfsmake1 grep
1059 lfsmake1 gzip
1060 lfsmake1 m4
1061 lfsmake1 make
1062 lfsmake1 patch
1063 lfsmake1 perl
46bbc13b 1064 lfsmake1 python3
69a6ec55
MT
1065 lfsmake1 sed
1066 lfsmake1 tar
1067 lfsmake1 texinfo
1068 lfsmake1 xz
85439ac7 1069 lfsmake1 bison
11b5e5cb 1070 lfsmake1 flex
69a6ec55 1071 lfsmake1 fake-environ
0ce11c68 1072 CUSTOM_PATH="${PATH}" lfsmake1 strip
69a6ec55 1073 lfsmake1 cleanup-toolchain
df5e82b3
MT
1074}
1075
1076buildbase() {
ebaecf2c 1077 LOGFILE="$BASEDIR/log/_build.base.log"
69a6ec55
MT
1078 export LOGFILE
1079 lfsmake2 stage2
1080 lfsmake2 linux KCFG="-headers"
1081 lfsmake2 man-pages
1082 lfsmake2 glibc
1083 lfsmake2 tzdata
1084 lfsmake2 cleanup-toolchain
1085 lfsmake2 zlib
b14c24ca 1086 lfsmake2 zstd
cf6c8e67
MT
1087 lfsmake2 autoconf
1088 lfsmake2 automake
1089 lfsmake2 libtool
69a6ec55
MT
1090 lfsmake2 binutils
1091 lfsmake2 gmp
69a6ec55
MT
1092 lfsmake2 mpfr
1093 lfsmake2 libmpc
cf6c8e67 1094 lfsmake2 libxcrypt
69a6ec55
MT
1095 lfsmake2 file
1096 lfsmake2 gcc
1097 lfsmake2 sed
69a6ec55
MT
1098 lfsmake2 berkeley
1099 lfsmake2 coreutils
1100 lfsmake2 iana-etc
1101 lfsmake2 m4
1102 lfsmake2 bison
69a6ec55 1103 lfsmake2 ncurses
69a6ec55
MT
1104 lfsmake2 perl
1105 lfsmake2 readline
69a6ec55 1106 lfsmake2 bzip2
3ece7859 1107 lfsmake2 xz
f407f05a 1108 lfsmake2 lzip
69a6ec55 1109 lfsmake2 pcre
b0c37190 1110 lfsmake2 pcre2
d701756a 1111 lfsmake2 gettext
241bf919
MT
1112 lfsmake2 attr
1113 lfsmake2 acl
69a6ec55
MT
1114 lfsmake2 bash
1115 lfsmake2 diffutils
69a6ec55
MT
1116 lfsmake2 ed
1117 lfsmake2 findutils
1118 lfsmake2 flex
1119 lfsmake2 gawk
d2315d00 1120 lfsmake2 go
69a6ec55
MT
1121 lfsmake2 grep
1122 lfsmake2 groff
1123 lfsmake2 gperf
1124 lfsmake2 gzip
1125 lfsmake2 hostname
ac36f9f2 1126 lfsmake2 whois
69a6ec55
MT
1127 lfsmake2 kbd
1128 lfsmake2 less
4720fa0d 1129 lfsmake2 pkg-config
50992c73 1130 lfsmake2 procps
69a6ec55
MT
1131 lfsmake2 make
1132 lfsmake2 man
69a6ec55
MT
1133 lfsmake2 net-tools
1134 lfsmake2 patch
1135 lfsmake2 psmisc
1136 lfsmake2 shadow
1137 lfsmake2 sysklogd
1138 lfsmake2 sysvinit
1139 lfsmake2 tar
1140 lfsmake2 texinfo
1141 lfsmake2 util-linux
69a6ec55 1142 lfsmake2 vim
69b3d63b 1143 lfsmake2 e2fsprogs
c9fb8808 1144 lfsmake2 jq
df5e82b3
MT
1145}
1146
15679d9f 1147buildipfire() {
ebaecf2c 1148 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1149 export LOGFILE
489145db
MT
1150 lfsmake2 configroot
1151 lfsmake2 initscripts
1152 lfsmake2 backup
c38f55fe 1153 lfsmake2 openssl
1ece41ec 1154 lfsmake2 kmod
e1c6cd05 1155 lfsmake2 udev
3755e358 1156 lfsmake2 popt
d4767896 1157 lfsmake2 libedit
489145db
MT
1158 lfsmake2 libusb
1159 lfsmake2 libusb-compat
1160 lfsmake2 libpcap
1161 lfsmake2 ppp
1162 lfsmake2 pptp
1163 lfsmake2 unzip
1164 lfsmake2 which
1165 lfsmake2 linux-firmware
489145db 1166 lfsmake2 dvb-firmwares
37b86fa9 1167 lfsmake2 xr819-firmware
489145db
MT
1168 lfsmake2 zd1211-firmware
1169 lfsmake2 rpi-firmware
26796f3a 1170 lfsmake2 intel-microcode
0e54ca26 1171 lfsmake2 pcengines-apu-firmware
489145db 1172 lfsmake2 bc
2a0947f2 1173 lfsmake2 u-boot MKIMAGE=1
489145db
MT
1174 lfsmake2 cpio
1175 lfsmake2 mdadm
1176 lfsmake2 dracut
de18b4de 1177 lfsmake2 libaio
489145db
MT
1178 lfsmake2 lvm2
1179 lfsmake2 multipath-tools
1180 lfsmake2 freetype
489145db
MT
1181 lfsmake2 libmnl
1182 lfsmake2 libnfnetlink
1183 lfsmake2 libnetfilter_queue
1184 lfsmake2 libnetfilter_conntrack
1185 lfsmake2 libnetfilter_cthelper
1186 lfsmake2 libnetfilter_cttimeout
1187 lfsmake2 iptables
66bc17dc 1188 lfsmake2 iproute2
0245f3b6 1189 lfsmake2 screen
54ead8ef 1190 lfsmake2 elfutils
8e6fb99d 1191
efafef16
AF
1192 # Kernelbuild ... current we have no platform that need
1193 # multi kernel builds so KCFG is empty
1194 lfsmake2 linux KCFG=""
1195 lfsmake2 rtl8189es KCFG=""
1196 lfsmake2 rtl8812au KCFG=""
8bb80576 1197 lfsmake2 rtl8822bu KCFG=""
efafef16 1198 lfsmake2 xradio KCFG=""
efafef16
AF
1199 lfsmake2 linux-initrd KCFG=""
1200
489145db
MT
1201 lfsmake2 libgpg-error
1202 lfsmake2 libgcrypt
1203 lfsmake2 libassuan
1204 lfsmake2 nettle
1a7db134 1205 lfsmake2 json-c
f3e62301 1206 lfsmake2 libconfig
489145db
MT
1207 lfsmake2 libevent
1208 lfsmake2 libevent2
1209 lfsmake2 expat
c8e9a7a8
WA
1210 lfsmake2 apr
1211 lfsmake2 aprutil
489145db
MT
1212 lfsmake2 unbound
1213 lfsmake2 gnutls
689246f5 1214 lfsmake2 libuv
489145db
MT
1215 lfsmake2 bind
1216 lfsmake2 dhcp
1217 lfsmake2 dhcpcd
1218 lfsmake2 boost
1219 lfsmake2 linux-atm
1220 lfsmake2 gdbm
1221 lfsmake2 pam
d44ce7d4 1222 lfsmake2 c-ares
489145db
MT
1223 lfsmake2 curl
1224 lfsmake2 tcl
1225 lfsmake2 sqlite
1226 lfsmake2 libffi
489145db 1227 lfsmake2 python3
150de02e 1228 lfsmake2 rust
321e91cd 1229 lfsmake2 rust-dissimilar
df47bf8b 1230 lfsmake2 rust-cfg-if
4307805f 1231 lfsmake2 rust-libc
6528a858 1232 lfsmake2 rust-getrandom
3062c37a 1233 lfsmake2 rust-typenum
b324df6b 1234 lfsmake2 rust-version-check
25a03398 1235 lfsmake2 rust-generic-array
338cde55 1236 lfsmake2 rust-cipher
1485f8d0 1237 lfsmake2 rust-hex
a24ff88b 1238 lfsmake2 rust-unicode-xid
96f567c2 1239 lfsmake2 rust-proc-macro2
87eab5be 1240 lfsmake2 rust-quote
edf4c981 1241 lfsmake2 rust-syn
02c14396 1242 lfsmake2 rust-home
5fab7845 1243 lfsmake2 rust-lazy-static
4349bbe8 1244 lfsmake2 rust-memchr
e5c94bdc 1245 lfsmake2 rust-aho-corasick
f2e7f66b 1246 lfsmake2 rust-regex-syntax
1cf6c790 1247 lfsmake2 rust-regex
ac04ede0 1248 lfsmake2 rust-ucd-trie
2bf0652e 1249 lfsmake2 rust-pest
a93be678 1250 lfsmake2 rust-semver-parser
86c55dbe 1251 lfsmake2 rust-semver
c195a517 1252 lfsmake2 rust-same-file
62d1644d 1253 lfsmake2 rust-walkdir
04a0915d 1254 lfsmake2 rust-dirs
556bd353 1255 lfsmake2 rust-toolchain_find
740d7032 1256 lfsmake2 rust-serde
848a1b01 1257 lfsmake2 rust-itoa
6cb1fb5d 1258 lfsmake2 rust-ryu
3e6bb6f9 1259 lfsmake2 rust-serde_json
9f7a109f 1260 lfsmake2 rust-synstructure
bf75fa26 1261 lfsmake2 rust-block-buffer
96f04526 1262 lfsmake2 rust-crypto-common
eb3db041 1263 lfsmake2 rust-digest
8d6764bb 1264 lfsmake2 rust-ppv-lite86
3851d787 1265 lfsmake2 rust-rand_core
cdcf6935 1266 lfsmake2 rust-rand_core-0.4.2
5df66668 1267 lfsmake2 rust-rand_core-0.3.1
79488e71 1268 lfsmake2 rust-rand_chacha
09b8af02 1269 lfsmake2 rust-rand_hc
8673bd7d 1270 lfsmake2 rust-rand
78914c73 1271 lfsmake2 rust-rdrand
90b6ebe8 1272 lfsmake2 rust-rand-0.4
44dd4dc8 1273 lfsmake2 rust-log
48a3d031 1274 lfsmake2 rust-num_cpus
52a14fbc 1275 lfsmake2 rust-crossbeam-utils
1d6ecb94 1276 lfsmake2 rust-autocfg
31f07518 1277 lfsmake2 rust-memoffset
b0d980bf 1278 lfsmake2 rust-scopeguard
519a98ae 1279 lfsmake2 rust-crossbeam-epoch
d7d3de14 1280 lfsmake2 rust-crossbeam-deque
fbf9f8a4 1281 lfsmake2 rust-either
508f56dc 1282 lfsmake2 rust-crossbeam-channel
a99886bc 1283 lfsmake2 rust-rayon-core
e601c0e3 1284 lfsmake2 rust-rayon
d1abeb8e 1285 lfsmake2 rust-remove_dir_all
3749286c 1286 lfsmake2 rust-tempdir
9fff2c63 1287 lfsmake2 rust-glob
f51709b4 1288 lfsmake2 rust-once_cell
e831bad8 1289 lfsmake2 rust-termcolor
e837da22 1290 lfsmake2 rust-toml
deb6672b 1291 lfsmake2 rust-serde_derive
1cdeadd5 1292 lfsmake2 rust-trybuild
216ac337 1293 lfsmake2 rust-unindent
f03b79b1 1294 lfsmake2 rust-proc-macro-hack
4c313740 1295 lfsmake2 rust-indoc-impl
474ee740 1296 lfsmake2 rust-indoc
a75c2b24 1297 lfsmake2 rust-instant
202602e0 1298 lfsmake2 rust-lock_api
1bd50189 1299 lfsmake2 rust-smallvec
eda91494 1300 lfsmake2 rust-parking_lot_core
d9c87622 1301 lfsmake2 rust-parking_lot
92ef3020 1302 lfsmake2 rust-paste-impl
f72d049d 1303 lfsmake2 rust-paste
d6f294fb 1304 lfsmake2 rust-ctor
b6c8f86e 1305 lfsmake2 rust-ghost
90490f88 1306 lfsmake2 rust-inventory-impl
3f0d5d36 1307 lfsmake2 rust-inventory
68051dc5 1308 lfsmake2 rust-pyo3-build-config
d2bd4114 1309 lfsmake2 rust-pyo3-macros-backend
b870fa68 1310 lfsmake2 rust-pyo3-macros
fb28b637 1311 lfsmake2 rust-pyo3
8a4495a4 1312 lfsmake2 gdb
b3ce3510
MT
1313 lfsmake2 grub
1314 lfsmake2 efivar
1315 lfsmake2 efibootmgr
40cdf896
AB
1316 lfsmake2 libtasn1
1317 lfsmake2 p11-kit
489145db
MT
1318 lfsmake2 ca-certificates
1319 lfsmake2 fireinfo
1320 lfsmake2 libnet
1321 lfsmake2 libnl
1322 lfsmake2 libnl-3
1323 lfsmake2 libidn
1324 lfsmake2 nasm
4f516b87
MF
1325 lfsmake2 libarchive
1326 lfsmake2 cmake
814a33ff
SS
1327 lfsmake2 ninja
1328 lfsmake2 meson
489145db 1329 lfsmake2 libjpeg
58d965fe 1330 lfsmake2 openjpeg
489145db
MT
1331 lfsmake2 libexif
1332 lfsmake2 libpng
1333 lfsmake2 libtiff
1334 lfsmake2 libart
1335 lfsmake2 gd
489145db
MT
1336 lfsmake2 slang
1337 lfsmake2 newt
1338 lfsmake2 libsmooth
489145db 1339 lfsmake2 libcap
b051eb68 1340 lfsmake2 libcap-ng
489145db
MT
1341 lfsmake2 pciutils
1342 lfsmake2 usbutils
1343 lfsmake2 libxml2
1344 lfsmake2 libxslt
3ad4e756 1345 lfsmake2 perl-BerkeleyDB
489145db
MT
1346 lfsmake2 cyrus-sasl
1347 lfsmake2 openldap
1348 lfsmake2 apache2
489145db
MT
1349 lfsmake2 web-user-interface
1350 lfsmake2 flag-icons
1351 lfsmake2 jquery
6033b271 1352 lfsmake2 bootstrap
489145db
MT
1353 lfsmake2 arping
1354 lfsmake2 beep
1df47cc9 1355 lfsmake2 libssh
ff075def 1356 lfsmake2 libinih
8a960584 1357 lfsmake2 cdrkit
489145db 1358 lfsmake2 dosfstools
574690dc 1359 lfsmake2 exfatprogs
489145db 1360 lfsmake2 reiserfsprogs
14192b69 1361 lfsmake2 liburcu
489145db
MT
1362 lfsmake2 xfsprogs
1363 lfsmake2 sysfsutils
1364 lfsmake2 fuse
1365 lfsmake2 ntfs-3g
1366 lfsmake2 ethtool
489145db 1367 lfsmake2 fcron
3ad4e756 1368 lfsmake2 perl-ExtUtils-PkgConfig
489145db 1369 lfsmake2 perl-GD
3ad4e756
AB
1370 lfsmake2 perl-GD-Graph
1371 lfsmake2 perl-GD-TextUtil
489145db
MT
1372 lfsmake2 perl-Device-SerialPort
1373 lfsmake2 perl-Device-Modem
1374 lfsmake2 perl-Apache-Htpasswd
bbcaca56 1375 lfsmake2 perl-Parse-Yapp
46426b69 1376 lfsmake2 perl-Data-UUID
141dd0d7 1377 lfsmake2 perl-Try-Tiny
3234da24 1378 lfsmake2 perl-HTTP-Message
26d87a84 1379 lfsmake2 perl-HTTP-Date
489145db
MT
1380 lfsmake2 gnupg
1381 lfsmake2 hdparm
1382 lfsmake2 sdparm
489145db 1383 lfsmake2 whatmask
29370584 1384 lfsmake2 libtirpc
489145db 1385 lfsmake2 conntrack-tools
489145db
MT
1386 lfsmake2 iputils
1387 lfsmake2 l7-protocols
489145db
MT
1388 lfsmake2 hwdata
1389 lfsmake2 logrotate
1390 lfsmake2 logwatch
1391 lfsmake2 misc-progs
1392 lfsmake2 nano
3ad4e756 1393 lfsmake2 perl-URI
294aa009
AF
1394 lfsmake2 perl-CGI
1395 lfsmake2 perl-Switch
3ad4e756
AB
1396 lfsmake2 perl-HTML-Tagset
1397 lfsmake2 perl-HTML-Parser
1398 lfsmake2 perl-HTML-Template
1399 lfsmake2 perl-Compress-Zlib
1400 lfsmake2 perl-Digest
1401 lfsmake2 perl-Digest-SHA1
1402 lfsmake2 perl-Digest-HMAC
1403 lfsmake2 perl-libwww
1404 lfsmake2 perl-LWP-Protocol-https
2f8ff4e8 1405 lfsmake2 perl-Net-HTTP
3ad4e756
AB
1406 lfsmake2 perl-Net-DNS
1407 lfsmake2 perl-Net-IPv4Addr
1408 lfsmake2 perl-Net_SSLeay
1409 lfsmake2 perl-IO-Stringy
1410 lfsmake2 perl-IO-Socket-SSL
1411 lfsmake2 perl-Unix-Syslog
1412 lfsmake2 perl-Mail-Tools
1413 lfsmake2 perl-MIME-Tools
1414 lfsmake2 perl-Net-Server
1415 lfsmake2 perl-Canary-Stability
1416 lfsmake2 perl-Convert-TNEF
1417 lfsmake2 perl-Convert-UUlib
1418 lfsmake2 perl-Archive-Tar
1419 lfsmake2 perl-Archive-Zip
1420 lfsmake2 perl-Text-Tabs+Wrap
1421 lfsmake2 perl-XML-Parser
1422 lfsmake2 perl-Crypt-PasswdMD5
1423 lfsmake2 perl-Net-Telnet
398669f7 1424 lfsmake2 python3-setuptools
d55a968a 1425 lfsmake2 python3-inotify
05fed717 1426 lfsmake2 python3-docutils
0882b3e4 1427 lfsmake2 python3-daemon
489145db 1428 lfsmake2 glib
489145db
MT
1429 lfsmake2 ntp
1430 lfsmake2 openssh
1431 lfsmake2 fontconfig
1432 lfsmake2 dejavu-fonts-ttf
70f6cba4 1433 lfsmake2 ubuntu-font-family
489145db
MT
1434 lfsmake2 freefont
1435 lfsmake2 pixman
1436 lfsmake2 cairo
0de1daf3
AB
1437 lfsmake2 harfbuzz
1438 lfsmake2 fribidi
489145db
MT
1439 lfsmake2 pango
1440 lfsmake2 rrdtool
489145db
MT
1441 lfsmake2 setup
1442 lfsmake2 libdnet
616395f3 1443 lfsmake2 jansson
91cc908f 1444 lfsmake2 yaml
3498300d 1445 lfsmake2 libhtp
1a5f0649 1446 lfsmake2 colm
2348cfff 1447 lfsmake2 ragel
52ebc66b 1448 lfsmake2 hyperscan
67752a95 1449 lfsmake2 suricata
489145db 1450 lfsmake2 oinkmaster
ef640882 1451 lfsmake2 ids-ruleset-sources
489145db
MT
1452 lfsmake2 squid
1453 lfsmake2 squidguard
1454 lfsmake2 calamaris
1455 lfsmake2 tcpdump
1456 lfsmake2 traceroute
1457 lfsmake2 vlan
1458 lfsmake2 wireless
1459 lfsmake2 pakfire
1460 lfsmake2 spandsp
adf3f4f4 1461 lfsmake2 lz4
489145db
MT
1462 lfsmake2 lzo
1463 lfsmake2 openvpn
489145db
MT
1464 lfsmake2 mpage
1465 lfsmake2 dbus
1466 lfsmake2 intltool
1467 lfsmake2 libdaemon
6064cd87 1468 lfsmake2 avahi
489145db 1469 lfsmake2 cups
489145db 1470 lfsmake2 lcms2
56170c2a 1471 lfsmake2 ghostscript
489145db
MT
1472 lfsmake2 qpdf
1473 lfsmake2 poppler
d3dabd4b 1474 lfsmake2 poppler-data
489145db
MT
1475 lfsmake2 cups-filters
1476 lfsmake2 epson-inkjet-printer-escpr
1477 lfsmake2 foomatic
1478 lfsmake2 hplip
1479 lfsmake2 cifs-utils
1480 lfsmake2 krb5
95849177 1481 lfsmake2 rpcsvc-proto
489145db 1482 lfsmake2 samba
18d000c4 1483 lfsmake2 netatalk
489145db
MT
1484 lfsmake2 sudo
1485 lfsmake2 mc
1486 lfsmake2 wget
1487 lfsmake2 bridge-utils
489145db
MT
1488 lfsmake2 smartmontools
1489 lfsmake2 htop
1490 lfsmake2 chkconfig
1491 lfsmake2 postfix
1492 lfsmake2 fetchmail
489145db 1493 lfsmake2 clamav
294aa009 1494 lfsmake2 perl-NetAddr-IP
489145db
MT
1495 lfsmake2 dma
1496 lfsmake2 alsa
1497 lfsmake2 mpfire
1498 lfsmake2 guardian
1499 lfsmake2 libid3tag
1500 lfsmake2 libmad
1501 lfsmake2 libogg
1502 lfsmake2 libvorbis
489145db
MT
1503 lfsmake2 flac
1504 lfsmake2 lame
1505 lfsmake2 sox
41f8d642 1506 lfsmake2 soxr
489145db
MT
1507 lfsmake2 libshout
1508 lfsmake2 xvid
1509 lfsmake2 libmpeg2
489145db
MT
1510 lfsmake2 gnump3d
1511 lfsmake2 rsync
489145db 1512 lfsmake2 rpcbind
14fb55a5 1513 lfsmake2 keyutils
489145db
MT
1514 lfsmake2 nfs
1515 lfsmake2 gnu-netcat
1516 lfsmake2 ncat
1517 lfsmake2 nmap
489145db
MT
1518 lfsmake2 etherwake
1519 lfsmake2 bwm-ng
1520 lfsmake2 sysstat
489145db
MT
1521 lfsmake2 strongswan
1522 lfsmake2 rng-tools
1523 lfsmake2 lsof
1524 lfsmake2 br2684ctl
1525 lfsmake2 pcmciautils
1526 lfsmake2 lm_sensors
25f26fb6 1527 lfsmake2 libstatgrab
489145db
MT
1528 lfsmake2 liboping
1529 lfsmake2 collectd
1530 lfsmake2 elinks
1531 lfsmake2 igmpproxy
489145db 1532 lfsmake2 opus
495cf3e0 1533 lfsmake2 python3-pyparsing
489145db
MT
1534 lfsmake2 spice-protocol
1535 lfsmake2 spice
15c01e30 1536 lfsmake2 sdl2
489145db 1537 lfsmake2 libusbredir
43c3a386 1538 lfsmake2 libseccomp
489145db 1539 lfsmake2 qemu
489145db 1540 lfsmake2 netpbm
489145db 1541 lfsmake2 netsnmpd
489145db 1542 lfsmake2 nagios_nrpe
2af354c2 1543 lfsmake2 nagios-plugins
489145db 1544 lfsmake2 icinga
01c2ea6b 1545 lfsmake2 observium-agent
489145db 1546 lfsmake2 ebtables
489145db 1547 lfsmake2 faad2
e91ceed6 1548 lfsmake2 alac
489145db
MT
1549 lfsmake2 ffmpeg
1550 lfsmake2 vdr
1551 lfsmake2 vdr_streamdev
489145db
MT
1552 lfsmake2 vdr_epgsearch
1553 lfsmake2 vdr_dvbapi
1554 lfsmake2 vdr_eepg
1555 lfsmake2 w_scan
489145db
MT
1556 lfsmake2 mpd
1557 lfsmake2 libmpdclient
1558 lfsmake2 mpc
985741db 1559 lfsmake2 perl-Net-CIDR-Lite
489145db
MT
1560 lfsmake2 perl-Net-SMTP-SSL
1561 lfsmake2 perl-MIME-Base64
1562 lfsmake2 perl-Authen-SASL
1563 lfsmake2 perl-MIME-Lite
1564 lfsmake2 perl-Email-Date-Format
1565 lfsmake2 git
1566 lfsmake2 squidclamav
1567 lfsmake2 vnstat
1568 lfsmake2 iw
1569 lfsmake2 wpa_supplicant
1570 lfsmake2 hostapd
489145db
MT
1571 lfsmake2 syslinux
1572 lfsmake2 tftpd
1573 lfsmake2 cpufrequtils
489145db
MT
1574 lfsmake2 gutenprint
1575 lfsmake2 apcupsd
67fbd255 1576 lfsmake2 fireperf
489145db
MT
1577 lfsmake2 iperf
1578 lfsmake2 iperf3
1579 lfsmake2 7zip
1580 lfsmake2 lynis
489145db
MT
1581 lfsmake2 sshfs
1582 lfsmake2 taglib
489145db
MT
1583 lfsmake2 sslh
1584 lfsmake2 perl-gettext
1585 lfsmake2 perl-Sort-Naturally
1586 lfsmake2 vdradmin
489145db 1587 lfsmake2 perl-DBI
489145db
MT
1588 lfsmake2 perl-DBD-SQLite
1589 lfsmake2 perl-File-ReadBackwards
489145db 1590 lfsmake2 openvmtools
489145db
MT
1591 lfsmake2 joe
1592 lfsmake2 monit
1593 lfsmake2 nut
1594 lfsmake2 watchdog
1595 lfsmake2 libpri
489145db
MT
1596 lfsmake2 usb_modeswitch
1597 lfsmake2 usb_modeswitch_data
1598 lfsmake2 zerofree
489145db
MT
1599 lfsmake2 minicom
1600 lfsmake2 ddrescue
489145db
MT
1601 lfsmake2 powertop
1602 lfsmake2 parted
1603 lfsmake2 swig
4c59cad1 1604 lfsmake2 dtc
2a0947f2 1605 lfsmake2 u-boot
6836e528 1606 lfsmake2 u-boot-friendlyarm
489145db 1607 lfsmake2 wireless-regdb
489145db 1608 lfsmake2 libsolv
489145db 1609 lfsmake2 ddns
269ccc44
AB
1610 lfsmake2 python3-toml
1611 lfsmake2 python3-pyproject2setuppy
1612 lfsmake2 python3-tomli
662b2a81 1613 lfsmake2 python3-setuptools-scm
269ccc44 1614 lfsmake2 python3-packaging
5996c281 1615 lfsmake2 python3-six
e0a05a80 1616 lfsmake2 python3-dateutil
d48ea6b5 1617 lfsmake2 python3-jmespath
a33ca4cc 1618 lfsmake2 python3-colorama
d2da17a1 1619 lfsmake2 python3-yaml
953f6f73 1620 lfsmake2 python3-s3transfer
d45d5247 1621 lfsmake2 python3-rsa
faa5472a 1622 lfsmake2 python3-pyasn1
05be1c64 1623 lfsmake2 python3-urllib3
4ab80c5d 1624 lfsmake2 python3-botocore
280ee7e7 1625 lfsmake2 aws-cli
576c02be 1626 lfsmake2 oci-python-sdk
d6196cdb 1627 lfsmake2 oci-cli
489145db 1628 lfsmake2 transmission
489145db 1629 lfsmake2 mtr
489145db
MT
1630 lfsmake2 minidlna
1631 lfsmake2 acpid
1632 lfsmake2 fping
1633 lfsmake2 telnet
1634 lfsmake2 xinetd
489145db 1635 lfsmake2 stress
489145db 1636 lfsmake2 sarg
489145db 1637 lfsmake2 nginx
489145db
MT
1638 lfsmake2 sysbench
1639 lfsmake2 strace
489145db
MT
1640 lfsmake2 ltrace
1641 lfsmake2 ipfire-netboot
1642 lfsmake2 lcdproc
489145db
MT
1643 lfsmake2 keepalived
1644 lfsmake2 ipvsadm
1645 lfsmake2 perl-Carp-Clan
1646 lfsmake2 perl-Date-Calc
1647 lfsmake2 perl-Date-Manip
1648 lfsmake2 perl-File-Tail
1649 lfsmake2 perl-TimeDate
1650 lfsmake2 swatch
1651 lfsmake2 tor
489145db
MT
1652 lfsmake2 wavemon
1653 lfsmake2 iptraf-ng
1654 lfsmake2 iotop
1655 lfsmake2 stunnel
489145db 1656 lfsmake2 bacula
b62c826f
MT
1657 lfsmake2 perl-Font-TTF
1658 lfsmake2 perl-IO-String
489145db 1659 lfsmake2 perl-PDF-API2
adb4174f 1660 lfsmake2 proxy-accounting
489145db
MT
1661 lfsmake2 pigz
1662 lfsmake2 tmux
1663 lfsmake2 perl-Text-CSV_XS
09b09b85 1664 lfsmake2 lua
489145db
MT
1665 lfsmake2 haproxy
1666 lfsmake2 ipset
489145db
MT
1667 lfsmake2 dnsdist
1668 lfsmake2 bird
8c855a58 1669 lfsmake2 libyang
1a7db134 1670 lfsmake2 frr
489145db
MT
1671 lfsmake2 dmidecode
1672 lfsmake2 mcelog
489145db
MT
1673 lfsmake2 libpciaccess
1674 lfsmake2 libyajl
1675 lfsmake2 libvirt
42fca290 1676 lfsmake2 libtalloc
489145db
MT
1677 lfsmake2 freeradius
1678 lfsmake2 perl-common-sense
1679 lfsmake2 perl-inotify2
1680 lfsmake2 perl-Net-IP
0d6cc79d 1681 lfsmake2 wio
773caa66 1682 lfsmake2 iftop
ddcd60f7 1683 lfsmake2 mdns-repeater
429af178 1684 lfsmake2 i2c-tools
4e9000b4 1685 lfsmake2 nss-myhostname
014b235a 1686 lfsmake2 dehydrated
c708fa15 1687 lfsmake2 shairport-sync
46114d79 1688 lfsmake2 borgbackup
50483167 1689 lfsmake2 lmdb
2397e513 1690 lfsmake2 knot
e1982c69 1691 lfsmake2 spectre-meltdown-checker
06fc6170 1692 lfsmake2 zabbix_agentd
82d176d3 1693 lfsmake2 flashrom
2aca6aa0 1694 lfsmake2 firmware-update
ffcef39d 1695 lfsmake2 tshark
9875e9f2 1696 lfsmake2 speedtest-cli
0db643ce 1697 lfsmake2 rfkill
44cc9a3d 1698 lfsmake2 amazon-ssm-agent
d938509e 1699 lfsmake2 libloc
4d275bcd 1700 lfsmake2 ncdu
76c5f3e0 1701 lfsmake2 lshw
68fbcc0e 1702 lfsmake2 socat
7300386b
AB
1703 lfsmake2 libcdada
1704 lfsmake2 pmacct
2b591415 1705 lfsmake2 squid-asnbl
df0635ab 1706 lfsmake2 qemu-ga
2f8ae1c2 1707 lfsmake2 gptfdisk
d0817963 1708}
df5e82b3
MT
1709
1710buildinstaller() {
1711 # Run installer scripts one by one
ebaecf2c 1712 LOGFILE="$BASEDIR/log/_build.installer.log"
df5e82b3 1713 export LOGFILE
489145db
MT
1714 lfsmake2 memtest
1715 lfsmake2 installer
ce9264a1 1716 # use toolchain bash for chroot to strip
19054331 1717 CUSTOM_PATH="${TOOLS_DIR}/bin" lfsmake2 strip
df5e82b3
MT
1718}
1719
1720buildpackages() {
ebaecf2c 1721 LOGFILE="$BASEDIR/log/_build.packages.log"
df5e82b3
MT
1722 export LOGFILE
1723 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1724
2f8ae1c2 1725
df5e82b3 1726 # Generating list of packages used
dc4ae0b7 1727 print_line "Generating packages list from logs"
df5e82b3 1728 rm -f $BASEDIR/doc/packages-list
ebaecf2c
AF
1729 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1730 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1731 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1732 fi
1733 done
7471f6ab 1734 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1735 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1736 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1737 rm -f $BASEDIR/doc/packages-list
c9673262 1738 # packages-list.txt is ready to be displayed for wiki page
f9783277 1739 print_status DONE
2f8ae1c2 1740
4b06f504 1741 # Update changelog
e49f7f0d 1742 cd $BASEDIR
c43b07fd
AF
1743 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1744 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1745 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1746
9607771a 1747 # Create images for install
489145db 1748 lfsmake2 cdrom
bada0832 1749
4dc82852 1750 # Check if there is a loop device for building in virtual environments
841663e7
MT
1751 modprobe loop 2>/dev/null
1752 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db 1753 lfsmake2 flash-images
4dc82852 1754 fi
c9673262 1755
c4dd9dfc 1756 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1757
0d909a4a 1758 ipfirepackages
e67a57fe 1759
b307417f 1760 cd $BASEDIR
744a04ea 1761
aafdd71b
AF
1762 # remove not useable iso on armv6l (needed to build flash images)
1763 [ "${BUILD_ARCH}" = "armv6l" ] && rm -rf *.iso
744a04ea 1764
5336aaa6 1765 for i in $(ls *.bz2 *.img.xz *.iso 2>/dev/null); do
b307417f
AF
1766 md5sum $i > $i.md5
1767 done
1768 cd $PWD
1769
e67a57fe
MT
1770 # Cleanup
1771 stdumount
1772 rm -rf $BASEDIR/build/tmp/*
1773
e67a57fe 1774 cd $PWD
e67a57fe
MT
1775}
1776
1777ipfirepackages() {
489145db 1778 lfsmake2 core-updates
5596077b
MT
1779
1780 local i
dc7d6b20 1781 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1782 i=$(basename ${i})
453b418b
MT
1783 if [ -e $BASEDIR/lfs/$i ]; then
1784 ipfiredist $i
1785 else
1786 echo -n $i
f9783277 1787 print_status SKIP
453b418b 1788 fi
fe7fe395 1789 done
78331e30 1790 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1791 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1792 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1793}
1794
bcb9dc13
MT
1795while [ $# -gt 0 ]; do
1796 case "${1}" in
1797 --target=*)
c2e810de 1798 configure_build "${1#--target=}"
bcb9dc13
MT
1799 ;;
1800 -*)
1801 exiterror "Unknown configuration option: ${1}"
1802 ;;
1803 *)
1804 # Found a command, so exit options parsing.
1805 break
1806 ;;
1807 esac
1808 shift
1809done
1810
df5e82b3 1811# See what we're supposed to do
2f8ae1c2 1812case "$1" in
df5e82b3 1813build)
f9783277
MT
1814 START_TIME=$(now)
1815
1816 # Clear screen
1817 ${INTERACTIVE} && clear
1818
d66e6fa8 1819 PACKAGE="$BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst"
df5e82b3 1820 #only restore on a clean disk
6c4cc7ea 1821 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1822 if [ ! -n "$PACKAGE" ]; then
f9783277 1823 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1824 prepareenv
1825 buildtoolchain
1826 else
d66e6fa8 1827 PACKAGENAME=${PACKAGE%.tar.zst}
f9783277 1828 print_build_stage "Packaged toolchain compilation"
df5e82b3 1829 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
cec532b4 1830 zstd -d < "${PACKAGE}" | tar x
df5e82b3
MT
1831 prepareenv
1832 else
1833 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1834 fi
1835 fi
1836 else
df5e82b3
MT
1837 prepareenv
1838 fi
5cfe86e6 1839
f9783277 1840 print_build_stage "Building LFS"
df5e82b3 1841 buildbase
15679d9f 1842
f9783277 1843 print_build_stage "Building IPFire"
15679d9f 1844 buildipfire
5cfe86e6 1845
f9783277 1846 print_build_stage "Building installer"
df5e82b3 1847 buildinstaller
15679d9f 1848
f9783277 1849 print_build_stage "Building packages"
df5e82b3 1850 buildpackages
2f8ae1c2 1851
f9783277 1852 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1853
1854 cd $BASEDIR
7a5ed24e 1855 tools/checknewlog.pl
e0c923f4 1856 tools/checkrootfiles
b307417f 1857 cd $PWD
a23731d1 1858
f9783277 1859 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1860 ;;
1861shell)
1862 # enter a shell inside LFS chroot
1863 # may be used to changed kernel settings
1864 prepareenv
1865 entershell
1866 ;;
df5e82b3 1867clean)
f9783277
MT
1868 print_line "Cleaning build directory..."
1869
df5e82b3
MT
1870 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1871 $LOSETUP -d $i 2>/dev/null
1872 done
b0c37190
MT
1873 #for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1874 # umount $i
1875 #done
df5e82b3
MT
1876 stdumount
1877 for i in `seq 0 7`; do
69a6ec55 1878 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1879 umount /dev/loop${i} 2>/dev/null;
1880 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1881 fi;
df5e82b3
MT
1882 done
1883 rm -rf $BASEDIR/build
1884 rm -rf $BASEDIR/cdrom
f9315063 1885 rm -rf $BASEDIR/packages
ebaecf2c 1886 rm -rf $BASEDIR/log
6c4cc7ea
MT
1887 if [ -h "${TOOLS_DIR}" ]; then
1888 rm -f "${TOOLS_DIR}"
df5e82b3 1889 fi
b307417f 1890 rm -f $BASEDIR/ipfire-*
f9783277 1891 print_status DONE
df5e82b3 1892 ;;
4e432799
MT
1893docker)
1894 # Build the docker image if it does not exist, yet
1895 if ! docker images -a | grep -q ^ipfire-builder; then
1896 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1897 print_status DONE
1898 else
1899 print_status FAIL
1900 exit 1
1901 fi
1902 fi
1903
1904 # Run the container and enter a shell
1905 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1906 ;;
c3db995c 1907downloadsrc)
df5e82b3
MT
1908 if [ ! -d $BASEDIR/cache ]; then
1909 mkdir $BASEDIR/cache
1910 fi
ebaecf2c 1911 mkdir -p $BASEDIR/log
857d9bf2 1912 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1913 FINISHED=0
1914 cd $BASEDIR/lfs
1915 for c in `seq $MAX_RETRIES`; do
2f8ae1c2 1916 if (( FINISHED==1 )); then
df5e82b3
MT
1917 break
1918 fi
1919 FINISHED=1
1920 cd $BASEDIR/lfs
1921 for i in *; do
1922 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1923 lfsmakecommoncheck ${i} || continue
1924
dc7d6b20 1925 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1926 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1927 if [ $? -ne 0 ]; then
f9783277 1928 print_status FAIL
df5e82b3
MT
1929 FINISHED=0
1930 else
1931 if [ $c -eq 1 ]; then
f9783277 1932 print_status DONE
df5e82b3
MT
1933 fi
1934 fi
1935 fi
1936 done
1937 done
e22c7973 1938 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1939 ERROR=0
1940 for i in *; do
1941 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1942 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1943 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1944 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1945 if [ $? -ne 0 ]; then
e22c7973 1946 echo -ne "MD5 difference in lfs/$i"
f9783277 1947 print_status FAIL
df5e82b3
MT
1948 ERROR=1
1949 fi
1950 fi
1951 done
1952 if [ $ERROR -eq 0 ]; then
e22c7973 1953 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1954 print_status DONE
e22c7973
MT
1955 else
1956 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1957 print_status FAIL
df5e82b3 1958 fi
e22c7973 1959 cd - >/dev/null 2>&1
df5e82b3 1960 ;;
df5e82b3 1961toolchain)
f9783277
MT
1962 # Clear screen
1963 ${INTERACTIVE} && clear
1964
df5e82b3 1965 prepareenv
f3b7cf47 1966 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1967 buildtoolchain
f74072a2 1968 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1969 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
d66e6fa8
MT
1970 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log \
1971 | zstd ${ZSTD_OPT} > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst
1972 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst \
dc7d6b20 1973 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1974 stdumount
1975 ;;
1976gettoolchain)
df5e82b3 1977 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1978 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
d66e6fa8 1979 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.zst ]; then
5bd13f01 1980 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1981 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1982 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1983 cd $BASEDIR/cache/toolchains
d66e6fa8 1984 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.zst $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1985 if [ $? -ne 0 ]; then
dc7d6b20 1986 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1987 else
5d099c0e 1988 if [ "`md5sum $PACKAGE.tar.zst | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1989 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1990 else
1991 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1992 fi
40a4ea4c 1993 fi
712d859c
MT
1994 else
1995 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1996 fi
1997 ;;
15679d9f 1998uploadsrc)
661d9388
CS
1999 if [ -z $IPFIRE_USER ]; then
2000 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 2001 print_status FAIL
661d9388
CS
2002 exit 1
2003 fi
ae23a606 2004
dbd455ef
MT
2005 URL_SOURCE="$(awk '/^URL_SOURCE/ { print $3 }' lfs/Config)"
2006
2007 rsync \
2008 --recursive \
2009 --update \
2010 --ignore-existing \
2011 --progress \
2012 --human-readable \
2013 --exclude="toolchains/" \
2014 "${BASEDIR}/cache/" \
2015 "${IPFIRE_USER}@${URL_SOURCE}"
661d9388 2016
15679d9f 2017 exit 0
0eab8e84 2018 ;;
bf7c473f 2019lang)
69a6ec55
MT
2020 echo -ne "Checking the translations for missing or obsolete strings..."
2021 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
2022 $BASEDIR/tools/sort_strings.pl en
2023 $BASEDIR/tools/sort_strings.pl de
2024 $BASEDIR/tools/sort_strings.pl fr
2025 $BASEDIR/tools/sort_strings.pl es
2026 $BASEDIR/tools/sort_strings.pl pl
2027 $BASEDIR/tools/sort_strings.pl ru
2028 $BASEDIR/tools/sort_strings.pl nl
2029 $BASEDIR/tools/sort_strings.pl tr
2030 $BASEDIR/tools/sort_strings.pl it
2031 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
2032 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
2033 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
2034 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
72c8478e 2035 $BASEDIR/tools/check_strings.pl pl > $BASEDIR/doc/language_issues.pl
69a6ec55
MT
2036 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
2037 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
2038 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
2039 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
2040 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 2041 print_status DONE
69a6ec55
MT
2042
2043 echo -ne "Updating language lists..."
2044 update_language_list ${BASEDIR}/src/installer/po
2045 update_language_list ${BASEDIR}/src/setup/po
f9783277 2046 print_status DONE
bf7c473f 2047 ;;
1fb7f56e
MT
2048update-contributors)
2049 update_contributors
2050 ;;
ba137dd8
MT
2051find-dependencies)
2052 shift
2053 exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
2054 ;;
4edcd4b2
LAH
2055check-manualpages)
2056 echo "Checking the manual pages for broken links..."
2f8ae1c2 2057
4edcd4b2
LAH
2058 chmod 755 $BASEDIR/tools/check_manualpages.pl
2059 if $BASEDIR/tools/check_manualpages.pl; then
2060 print_status DONE
2061 else
2062 print_status FAIL
2063 fi
2064 ;;
6b8cff41 2065*)
a55f90e9 2066 echo "Usage: $0 [OPTIONS] {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors|find-dependencies|check-manualpages}"
6b8cff41
MT
2067 cat doc/make.sh-usage
2068 ;;
3ea75603 2069esac